org.codehaus.groovy.antlr.java

## Class JavaRecognizer

- java.lang.Object
- - antlr.Parser
  - - antlr.LLkParser
    - - org.codehaus.groovy.antlr.java.JavaRecognizer

- All Implemented Interfaces:
    JavaTokenTypes

      public class JavaRecognizer
      extends antlr.LLkParser
      implements JavaTokenTypes

  Java 1.5 Recognizer Run 'java Main [-showtree] directory-full-of-java-files' [The -showtree option pops up a Swing frame that shows the AST constructed from the parser.] Run 'java Main ' Contributing authors: Jeremy Rayner groovy@ross-rayner.com John Mitchell johnm@non.net Terence Parr parrt@magelang.com John Lilley jlilley@empathy.com Scott Stanchfield thetick@magelang.com Markus Mohnen mohnen@informatik.rwth-aachen.de Peter Williams pete.williams@sun.com Allan Jacobs Allan.Jacobs@eng.sun.com Steve Messick messick@redhills.com John Pybus john@pybus.org Version 1.00 December 9, 1997 -- initial release Version 1.01 December 10, 1997 fixed bug in octal def (0..7 not 0..8) Version 1.10 August 1998 (parrt) added tree construction fixed definition of WS,comments for mac,pc,unix newlines added unary plus Version 1.11 (Nov 20, 1998) Added "shutup" option to turn off last ambig warning. Fixed inner class def to allow named class defs as statements synchronized requires compound not simple statement add [] after builtInType DOT class in primaryExpression "const" is reserved but not valid..removed from modifiers Version 1.12 (Feb 2, 1999) Changed LITERAL_xxx to xxx in tree grammar. Updated java.g to use tokens {...} now for 2.6.0 (new feature). Version 1.13 (Apr 23, 1999) Didn't have (stat)? for else clause in tree parser. Didn't gen ASTs for interface extends. Updated tree parser too. Updated to 2.6.0. Version 1.14 (Jun 20, 1999) Allowed final/abstract on local classes. Removed local interfaces from methods Put instanceof precedence where it belongs...in relationalExpr It also had expr not type as arg; fixed it. Missing ! on SEMI in classBlock fixed: (expr) + "string" was parsed incorrectly (+ as unary plus). fixed: didn't like Object[].class in parser or tree parser Version 1.15 (Jun 26, 1999) Screwed up rule with instanceof in it. :( Fixed. Tree parser didn't like (expr).something; fixed. Allowed multiple inheritance in tree grammar. oops. Version 1.16 (August 22, 1999) Extending an interface built a wacky tree: had extra EXTENDS. Tree grammar didn't allow multiple superinterfaces. Tree grammar didn't allow empty var initializer: {} Version 1.17 (October 12, 1999) ESC lexer rule allowed 399 max not 377 max. java.tree.g didn't handle the expression of synchronized statements. Version 1.18 (August 12, 2001) Terence updated to Java 2 Version 1.3 by observing/combining work of Allan Jacobs and Steve Messick. Handles 1.3 src. Summary: o primary didn't include boolean.class kind of thing o constructor calls parsed explicitly now: see explicitConstructorInvocation o add strictfp modifier o missing objBlock after new expression in tree grammar o merged local class definition alternatives, moved after declaration o fixed problem with ClassName.super.field o reordered some alternatives to make things more efficient o long and double constants were not differentiated from int/float o whitespace rule was inefficient: matched only one char o add an examples directory with some nasty 1.3 cases o made Main.java use buffered IO and a Reader for Unicode support o supports UNICODE? Using Unicode charVocabulay makes code file big, but only in the bitsets at the end. I need to make ANTLR generate unicode bitsets more efficiently. Version 1.19 (April 25, 2002) Terence added in nice fixes by John Pybus concerning floating constants and problems with super() calls. John did a nice reorg of the primary/postfix expression stuff to read better and makes f.g.super() parse properly (it was METHOD_CALL not a SUPER_CTOR_CALL). Also: o "finally" clause was a root...made it a child of "try" o Added stuff for asserts too for Java 1.4, but *commented out* as it is not backward compatible. Version 1.20 (October 27, 2002) Terence ended up reorging John Pybus' stuff to remove some nondeterminisms and some syntactic predicates. Note that the grammar is stricter now; e.g., this(...) must be the first statement. Trinary ?: operator wasn't working as array name: (isBig ? bigDigits : digits)[i]; Checked parser/tree parser on source for Resin-2.0.5, jive-2.1.1, jdk 1.3.1, Lucene, antlr 2.7.2a4, and the 110k-line jGuru server source. Version 1.21 (October 17, 2003) Fixed lots of problems including: Ray Waldin: add typeDefinition to interfaceBlock in java.tree.g He found a problem/fix with floating point that start with 0 Ray also fixed problem that (int.class) was not recognized. Thorsten van Ellen noticed that \n are allowed incorrectly in strings. TJP fixed CHAR_LITERAL analogously. Version 1.21.2 (March, 2003) Changes by Matt Quail to support generics (as per JDK1.5/JSR14) Notes: o We only allow the "extends" keyword and not the "implements" keyword, since thats what JSR14 seems to imply. o Thanks to Monty Zukowski for his help on the antlr-interest mail list. o Thanks to Alan Eliasen for testing the grammar over his Fink source base Version 1.22 (July, 2004) Changes by Michael Studman to support Java 1.5 language extensions Notes: o Added support for annotations types o Finished off Matt Quail's generics enhancements to support bound type arguments o Added support for new for statement syntax o Added support for static import syntax o Added support for enum types o Tested against JDK 1.5 source base and source base of jdigraph project o Thanks to Matt Quail for doing the hard part by doing most of the generics work Version 1.22.1 (July 28, 2004) Bug/omission fixes for Java 1.5 language support o Fixed tree structure bug with classOrInterface - thanks to Pieter Vangorpto for spotting this o Fixed bug where incorrect handling of SR and BSR tokens would cause type parameters to be recognised as type arguments. o Enabled type parameters on constructors, annotations on enum constants and package definitions o Fixed problems when parsing if ((char.class.equals(c))) {} - solution by Matt Quail at Cenqua Version 1.22.2 (July 28, 2004) Slight refactoring of Java 1.5 language support o Refactored for/"foreach" productions so that original literal "for" literal is still used but the for sub-clauses vary by token type o Fixed bug where type parameter was not included in generic constructor's branch of AST Version 1.22.3 (August 26, 2004) Bug fixes as identified by Michael Stahl; clean up of tabs/spaces and other refactorings o Fixed typeParameters omission in identPrimary and newStatement o Replaced GT reconcilliation code with simple semantic predicate o Adapted enum/assert keyword checking support from Michael Stahl's java15 grammar o Refactored typeDefinition production and field productions to reduce duplication Version 1.22.4 (October 21, 2004) Small bux fixes o Added typeArguments to explicitConstructorInvocation, e.g. new MyParameterised() o Added typeArguments to postfixExpression productions for anonymous inner class super constructor invocation, e.g. new Outer().super() o Fixed bug in array declarations identified by Geoff Roy Version 1.22.4.j.1 Changes by Jeremy Rayner to support java2groovy tool o I have taken java.g for Java1.5 from Michael Studman (1.22.4) and have made some changes to enable use by java2groovy tool (Jan 2007) Based on an original grammar released in the PUBLIC DOMAIN

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String[]` | `_tokenNames`
    `static antlr.collections.impl.BitSet` | `_tokenSet_0`
    `static antlr.collections.impl.BitSet` | `_tokenSet_1`
    `static antlr.collections.impl.BitSet` | `_tokenSet_10`
    `static antlr.collections.impl.BitSet` | `_tokenSet_11`
    `static antlr.collections.impl.BitSet` | `_tokenSet_12`
    `static antlr.collections.impl.BitSet` | `_tokenSet_13`
    `static antlr.collections.impl.BitSet` | `_tokenSet_14`
    `static antlr.collections.impl.BitSet` | `_tokenSet_15`
    `static antlr.collections.impl.BitSet` | `_tokenSet_16`
    `static antlr.collections.impl.BitSet` | `_tokenSet_17`
    `static antlr.collections.impl.BitSet` | `_tokenSet_18`
    `static antlr.collections.impl.BitSet` | `_tokenSet_19`
    `static antlr.collections.impl.BitSet` | `_tokenSet_2`
    `static antlr.collections.impl.BitSet` | `_tokenSet_20`
    `static antlr.collections.impl.BitSet` | `_tokenSet_21`
    `static antlr.collections.impl.BitSet` | `_tokenSet_22`
    `static antlr.collections.impl.BitSet` | `_tokenSet_23`
    `static antlr.collections.impl.BitSet` | `_tokenSet_24`
    `static antlr.collections.impl.BitSet` | `_tokenSet_25`
    `static antlr.collections.impl.BitSet` | `_tokenSet_26`
    `static antlr.collections.impl.BitSet` | `_tokenSet_27`
    `static antlr.collections.impl.BitSet` | `_tokenSet_28`
    `static antlr.collections.impl.BitSet` | `_tokenSet_29`
    `static antlr.collections.impl.BitSet` | `_tokenSet_3`
    `static antlr.collections.impl.BitSet` | `_tokenSet_30`
    `static antlr.collections.impl.BitSet` | `_tokenSet_31`
    `static antlr.collections.impl.BitSet` | `_tokenSet_32`
    `static antlr.collections.impl.BitSet` | `_tokenSet_33`
    `static antlr.collections.impl.BitSet` | `_tokenSet_34`
    `static antlr.collections.impl.BitSet` | `_tokenSet_35`
    `static antlr.collections.impl.BitSet` | `_tokenSet_36`
    `static antlr.collections.impl.BitSet` | `_tokenSet_37`
    `static antlr.collections.impl.BitSet` | `_tokenSet_38`
    `static antlr.collections.impl.BitSet` | `_tokenSet_39`
    `static antlr.collections.impl.BitSet` | `_tokenSet_4`
    `static antlr.collections.impl.BitSet` | `_tokenSet_40`
    `static antlr.collections.impl.BitSet` | `_tokenSet_41`
    `static antlr.collections.impl.BitSet` | `_tokenSet_42`
    `static antlr.collections.impl.BitSet` | `_tokenSet_43`
    `static antlr.collections.impl.BitSet` | `_tokenSet_44`
    `static antlr.collections.impl.BitSet` | `_tokenSet_45`
    `static antlr.collections.impl.BitSet` | `_tokenSet_46`
    `static antlr.collections.impl.BitSet` | `_tokenSet_47`
    `static antlr.collections.impl.BitSet` | `_tokenSet_48`
    `static antlr.collections.impl.BitSet` | `_tokenSet_49`
    `static antlr.collections.impl.BitSet` | `_tokenSet_5`
    `static antlr.collections.impl.BitSet` | `_tokenSet_6`
    `static antlr.collections.impl.BitSet` | `_tokenSet_7`
    `static antlr.collections.impl.BitSet` | `_tokenSet_8`
    `static antlr.collections.impl.BitSet` | `_tokenSet_9`

    - ### Fields inherited from class antlr.Parser

      `astFactory, inputState, returnAST, tokenNames, tokenTypeToASTClassMap, traceDepth`

    - ### Fields inherited from interface org.codehaus.groovy.antlr.java.JavaTokenTypes

      `ABSTRACT, ANNOTATION, ANNOTATION_ARRAY_INIT, ANNOTATION_DEF, ANNOTATION_FIELD_DEF, ANNOTATION_MEMBER_VALUE_PAIR, ANNOTATIONS, ARRAY_DECLARATOR, ARRAY_INIT, ASSIGN, AT, BAND, BAND_ASSIGN, BLOCK, BNOT, BOR, BOR_ASSIGN, BSR, BSR_ASSIGN, BXOR, BXOR_ASSIGN, CASE_GROUP, CHAR_LITERAL, CLASS_DEF, COLON, COMMA, CTOR_CALL, DEC, DIV, DIV_ASSIGN, DOT, ELIST, EMPTY_STAT, ENUM_CONSTANT_DEF, ENUM_DEF, EOF, EQUAL, ESC, EXPONENT, EXPR, EXTENDS_CLAUSE, FINAL, FLOAT_SUFFIX, FOR_CONDITION, FOR_EACH_CLAUSE, FOR_INIT, FOR_ITERATOR, GE, GT, HEX_DIGIT, IDENT, IMPLEMENTS_CLAUSE, IMPORT, INC, INDEX_OP, INSTANCE_INIT, INTERFACE_DEF, LABELED_STAT, LAND, LBRACK, LCURLY, LE, LITERAL_assert, LITERAL_boolean, LITERAL_break, LITERAL_byte, LITERAL_case, LITERAL_catch, LITERAL_char, LITERAL_class, LITERAL_continue, LITERAL_default, LITERAL_do, LITERAL_double, LITERAL_else, LITERAL_enum, LITERAL_extends, LITERAL_false, LITERAL_finally, LITERAL_float, LITERAL_for, LITERAL_if, LITERAL_implements, LITERAL_import, LITERAL_instanceof, LITERAL_int, LITERAL_interface, LITERAL_long, LITERAL_native, LITERAL_new, LITERAL_null, LITERAL_package, LITERAL_private, LITERAL_protected, LITERAL_public, LITERAL_return, LITERAL_short, LITERAL_static, LITERAL_super, LITERAL_switch, LITERAL_synchronized, LITERAL_this, LITERAL_threadsafe, LITERAL_throw, LITERAL_throws, LITERAL_transient, LITERAL_true, LITERAL_try, LITERAL_void, LITERAL_volatile, LITERAL_while, LNOT, LOR, LPAREN, LT, METHOD_CALL, METHOD_DEF, MINUS, MINUS_ASSIGN, ML_COMMENT, MOD, MOD_ASSIGN, MODIFIERS, NOT_EQUAL, NULL_TREE_LOOKAHEAD, NUM_DOUBLE, NUM_FLOAT, NUM_INT, NUM_LONG, OBJBLOCK, PACKAGE_DEF, PARAMETER_DEF, PARAMETERS, PLUS, PLUS_ASSIGN, POST_DEC, POST_INC, QUESTION, RBRACK, RCURLY, RPAREN, SEMI, SL, SL_ASSIGN, SL_COMMENT, SLIST, SR, SR_ASSIGN, STAR, STAR_ASSIGN, STATIC_IMPORT, STATIC_INIT, STRICTFP, STRING_LITERAL, SUPER_CTOR_CALL, TRIPLE_DOT, TYPE, TYPE_ARGUMENT, TYPE_ARGUMENTS, TYPE_LOWER_BOUNDS, TYPE_PARAMETER, TYPE_PARAMETERS, TYPE_UPPER_BOUNDS, TYPECAST, UNARY_MINUS, UNARY_PLUS, VARIABLE_DEF, VARIABLE_PARAMETER_DEF, VOCAB, WILDCARD_TYPE, WS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `JavaRecognizer(antlr.ParserSharedInputState state)`
    `` | `JavaRecognizer(antlr.TokenBuffer tokenBuf)`
    `protected` | `JavaRecognizer(antlr.TokenBuffer tokenBuf, int k)`
    `` | `JavaRecognizer(antlr.TokenStream lexer)`
    `protected` | `JavaRecognizer(antlr.TokenStream lexer, int k)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `aCase()`
    `void` | `additiveExpression()`
    `void` | `andExpression()`
    `void` | `annotation()`
    `void` | `annotationArguments()`
    `void` | `annotationBlock()`
    `void` | `annotationDefinition(antlr.collections.AST modifiers)`
    `void` | `annotationField()`
    `void` | `annotationMemberArrayInitializer()`
    `void` | `annotationMemberArrayValueInitializer()`
    `void` | `annotationMemberValueInitializer()`
    `void` | `annotationMemberValuePair()`
    `void` | `annotations()`
    `void` | `anntotationMemberValuePairs()`
    `void` | `argList()`
    `void` | `arrayInitializer()`
    `void` | `assignmentExpression()`
    `protected void` | `buildTokenTypeASTClassMap()`
    `void` | `builtInType()`
    `void` | `builtInTypeArraySpec(boolean addImagNode)`
    `void` | `builtInTypeSpec(boolean addImagNode)`
    `void` | `casesGroup()`
    `void` | `caseSList()`
    `void` | `classBlock()`
    `void` | `classDefinition(antlr.collections.AST modifiers)`
    `void` | `classField()`
    `void` | `classOrInterfaceType(boolean addImagNode)`
    `void` | `classTypeSpec(boolean addImagNode)`
    `void` | `compilationUnit()`
    `void` | `compoundStatement()`
    `void` | `conditionalExpression()`
    `void` | `constant()`
    `void` | `constructorBody()`
    `antlr.collections.AST` | `create(int type, java.lang.String txt, antlr.Token first, antlr.Token last)` Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g.
    `void` | `ctorHead()`
    `void` | `declaration()`
    `void` | `declaratorBrackets(antlr.collections.AST typ)`
    `void` | `enumBlock()`
    `void` | `enumConstant()`
    `void` | `enumConstantBlock()`
    `void` | `enumConstantField()`
    `void` | `enumDefinition(antlr.collections.AST modifiers)`
    `void` | `equalityExpression()`
    `void` | `exclusiveOrExpression()`
    `void` | `explicitConstructorInvocation()` Catch obvious constructor calls, but not the expr.super(...) calls
    `void` | `expression()`
    `void` | `expressionList()`
    `void` | `finallyClause()`
    `void` | `forCond()`
    `void` | `forEachClause()`
    `void` | `forInit()`
    `void` | `forIter()`
    `void` | `forStatement()`
    `JavaLexer` | `getLexer()`
    `void` | `handler()`
    `void` | `identifier()`
    `void` | `identifierStar()`
    `void` | `identPrimary()` Match a, a.b.c refs, a.b.c(...) refs, a.b.c[], a.b.c[].class, and a.b.c.class refs.
    `void` | `implementsClause()`
    `void` | `importDefinition()`
    `void` | `inclusiveOrExpression()`
    `void` | `initializer()`
    `void` | `interfaceBlock()`
    `void` | `interfaceDefinition(antlr.collections.AST modifiers)`
    `void` | `interfaceExtends()`
    `void` | `interfaceField()`
    `void` | `logicalAndExpression()`
    `void` | `logicalOrExpression()`
    `static JavaRecognizer` | `make(antlr.InputBuffer in)`
    `static JavaRecognizer` | `make(java.io.InputStream in)`
    `static JavaRecognizer` | `make(JavaLexer lexer)` This factory is the correct way to wire together a Groovy parser and lexer.
    `static JavaRecognizer` | `make(antlr.LexerSharedInputState in)`
    `static JavaRecognizer` | `make(java.io.Reader in)`
    `void` | `modifier()`
    `void` | `modifiers()`
    `void` | `multicatch_types()`
    `void` | `multicatch()`
    `void` | `multiplicativeExpression()`
    `void` | `newArrayDeclarator()`
    `void` | `newExpression()` object instantiation.
    `void` | `packageDefinition()`
    `void` | `parameterDeclaration()`
    `void` | `parameterDeclarationList()`
    `void` | `parameterModifier()`
    `void` | `postfixExpression()`
    `void` | `primaryExpression()`
    `void` | `relationalExpression()`
    `void` | `setFilename(java.lang.String f)`
    `void` | `setSourceBuffer(SourceBuffer sourceBuffer)`
    `void` | `shiftExpression()`
    `void` | `statement()`
    `void` | `superClassClause()`
    `void` | `throwsClause()`
    `void` | `traditionalForClause()`
    `void` | `tryBlock()`
    `void` | `type()`
    `void` | `typeArgument()`
    `void` | `typeArgumentBounds()`
    `void` | `typeArguments()`
    `void` | `typeArgumentsOrDiamond()`
    `protected void` | `typeArgumentsOrParametersEnd()`
    `void` | `typeArgumentSpec()`
    `void` | `typeDefinition()`
    `protected void` | `typeDefinitionInternal(antlr.collections.AST mods)`
    `void` | `typeParameter()`
    `void` | `typeParameterBounds()`
    `void` | `typeParameters()`
    `void` | `typeSpec(boolean addImagNode)`
    `void` | `unaryExpression()`
    `void` | `unaryExpressionNotPlusMinus()`
    `void` | `variableDeclarator(antlr.collections.AST mods, antlr.collections.AST t)` Declaration of a variable.
    `void` | `variableDefinitions(antlr.collections.AST mods, antlr.collections.AST t)`
    `void` | `variableLengthParameterDeclaration()`
    `void` | `varInitializer()`
    `void` | `wildcardType()`

    - ### Methods inherited from class antlr.LLkParser

      `consume, LA, LT, traceIn, traceOut`

    - ### Methods inherited from class antlr.Parser

      `addMessageListener, addParserListener, addParserMatchListener, addParserTokenListener, addSemanticPredicateListener, addSyntacticPredicateListener, addTraceListener, consumeUntil, consumeUntil, defaultDebuggingSetup, getAST, getASTFactory, getFilename, getInputState, getTokenName, getTokenNames, getTokenTypeToASTClassMap, isDebugMode, mark, match, match, matchNot, panic, recover, removeMessageListener, removeParserListener, removeParserMatchListener, removeParserTokenListener, removeSemanticPredicateListener, removeSyntacticPredicateListener, removeTraceListener, reportError, reportError, reportWarning, rewind, setASTFactory, setASTNodeClass, setASTNodeType, setDebugMode, setIgnoreInvalidDebugCalls, setInputState, setTokenBuffer, traceIndent`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _tokenNames

          public static final java.lang.String[] _tokenNames

    - #### _tokenSet_0

          public static final antlr.collections.impl.BitSet _tokenSet_0

    - #### _tokenSet_1

          public static final antlr.collections.impl.BitSet _tokenSet_1

    - #### _tokenSet_2

          public static final antlr.collections.impl.BitSet _tokenSet_2

    - #### _tokenSet_3

          public static final antlr.collections.impl.BitSet _tokenSet_3

    - #### _tokenSet_4

          public static final antlr.collections.impl.BitSet _tokenSet_4

    - #### _tokenSet_5

          public static final antlr.collections.impl.BitSet _tokenSet_5

    - #### _tokenSet_6

          public static final antlr.collections.impl.BitSet _tokenSet_6

    - #### _tokenSet_7

          public static final antlr.collections.impl.BitSet _tokenSet_7

    - #### _tokenSet_8

          public static final antlr.collections.impl.BitSet _tokenSet_8

    - #### _tokenSet_9

          public static final antlr.collections.impl.BitSet _tokenSet_9

    - #### _tokenSet_10

          public static final antlr.collections.impl.BitSet _tokenSet_10

    - #### _tokenSet_11

          public static final antlr.collections.impl.BitSet _tokenSet_11

    - #### _tokenSet_12

          public static final antlr.collections.impl.BitSet _tokenSet_12

    - #### _tokenSet_13

          public static final antlr.collections.impl.BitSet _tokenSet_13

    - #### _tokenSet_14

          public static final antlr.collections.impl.BitSet _tokenSet_14

    - #### _tokenSet_15

          public static final antlr.collections.impl.BitSet _tokenSet_15

    - #### _tokenSet_16

          public static final antlr.collections.impl.BitSet _tokenSet_16

    - #### _tokenSet_17

          public static final antlr.collections.impl.BitSet _tokenSet_17

    - #### _tokenSet_18

          public static final antlr.collections.impl.BitSet _tokenSet_18

    - #### _tokenSet_19

          public static final antlr.collections.impl.BitSet _tokenSet_19

    - #### _tokenSet_20

          public static final antlr.collections.impl.BitSet _tokenSet_20

    - #### _tokenSet_21

          public static final antlr.collections.impl.BitSet _tokenSet_21

    - #### _tokenSet_22

          public static final antlr.collections.impl.BitSet _tokenSet_22

    - #### _tokenSet_23

          public static final antlr.collections.impl.BitSet _tokenSet_23

    - #### _tokenSet_24

          public static final antlr.collections.impl.BitSet _tokenSet_24

    - #### _tokenSet_25

          public static final antlr.collections.impl.BitSet _tokenSet_25

    - #### _tokenSet_26

          public static final antlr.collections.impl.BitSet _tokenSet_26

    - #### _tokenSet_27

          public static final antlr.collections.impl.BitSet _tokenSet_27

    - #### _tokenSet_28

          public static final antlr.collections.impl.BitSet _tokenSet_28

    - #### _tokenSet_29

          public static final antlr.collections.impl.BitSet _tokenSet_29

    - #### _tokenSet_30

          public static final antlr.collections.impl.BitSet _tokenSet_30

    - #### _tokenSet_31

          public static final antlr.collections.impl.BitSet _tokenSet_31

    - #### _tokenSet_32

          public static final antlr.collections.impl.BitSet _tokenSet_32

    - #### _tokenSet_33

          public static final antlr.collections.impl.BitSet _tokenSet_33

    - #### _tokenSet_34

          public static final antlr.collections.impl.BitSet _tokenSet_34

    - #### _tokenSet_35

          public static final antlr.collections.impl.BitSet _tokenSet_35

    - #### _tokenSet_36

          public static final antlr.collections.impl.BitSet _tokenSet_36

    - #### _tokenSet_37

          public static final antlr.collections.impl.BitSet _tokenSet_37

    - #### _tokenSet_38

          public static final antlr.collections.impl.BitSet _tokenSet_38

    - #### _tokenSet_39

          public static final antlr.collections.impl.BitSet _tokenSet_39

    - #### _tokenSet_40

          public static final antlr.collections.impl.BitSet _tokenSet_40

    - #### _tokenSet_41

          public static final antlr.collections.impl.BitSet _tokenSet_41

    - #### _tokenSet_42

          public static final antlr.collections.impl.BitSet _tokenSet_42

    - #### _tokenSet_43

          public static final antlr.collections.impl.BitSet _tokenSet_43

    - #### _tokenSet_44

          public static final antlr.collections.impl.BitSet _tokenSet_44

    - #### _tokenSet_45

          public static final antlr.collections.impl.BitSet _tokenSet_45

    - #### _tokenSet_46

          public static final antlr.collections.impl.BitSet _tokenSet_46

    - #### _tokenSet_47

          public static final antlr.collections.impl.BitSet _tokenSet_47

    - #### _tokenSet_48

          public static final antlr.collections.impl.BitSet _tokenSet_48

    - #### _tokenSet_49

          public static final antlr.collections.impl.BitSet _tokenSet_49

  - ### Constructor Detail

    - #### JavaRecognizer

          protected JavaRecognizer(antlr.TokenBuffer tokenBuf,
                                   int k)

    - #### JavaRecognizer

          public JavaRecognizer(antlr.TokenBuffer tokenBuf)

    - #### JavaRecognizer

          protected JavaRecognizer(antlr.TokenStream lexer,
                                   int k)

    - #### JavaRecognizer

          public JavaRecognizer(antlr.TokenStream lexer)

    - #### JavaRecognizer

          public JavaRecognizer(antlr.ParserSharedInputState state)

  - ### Method Detail

    - #### make

          public static JavaRecognizer make(JavaLexer lexer)

      This factory is the correct way to wire together a Groovy parser and lexer.

    - #### make

          public static JavaRecognizer make(java.io.InputStream in)

    - #### make

          public static JavaRecognizer make(java.io.Reader in)

    - #### make

          public static JavaRecognizer make(antlr.InputBuffer in)

    - #### make

          public static JavaRecognizer make(antlr.LexerSharedInputState in)

    - #### getLexer

          public JavaLexer getLexer()

    - #### setFilename

          public void setFilename(java.lang.String f)

      Overrides:
        `setFilename` in class `antlr.Parser`

    - #### setSourceBuffer

          public void setSourceBuffer(SourceBuffer sourceBuffer)

    - #### create

          public antlr.collections.AST create(int type,
                                              java.lang.String txt,
                                              antlr.Token first,
                                              antlr.Token last)

      Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g. line numbers) to be used in place of antlr tree construction syntax, i.e. #[TOKEN,"text"] becomes create(TOKEN,"text",anotherToken) todo - change antlr.ASTFactory to do this instead...

    - #### compilationUnit

          public final void compilationUnit()
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotations

          public final void annotations()
                                 throws antlr.RecognitionException,
                                        antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### packageDefinition

          public final void packageDefinition()
                                       throws antlr.RecognitionException,
                                              antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### importDefinition

          public final void importDefinition()
                                      throws antlr.RecognitionException,
                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeDefinition

          public final void typeDefinition()
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### identifier

          public final void identifier()
                                throws antlr.RecognitionException,
                                       antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### identifierStar

          public final void identifierStar()
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### modifiers

          public final void modifiers()
                               throws antlr.RecognitionException,
                                      antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeDefinitionInternal

          protected final void typeDefinitionInternal(antlr.collections.AST mods)
                                               throws antlr.RecognitionException,
                                                      antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### classDefinition

          public final void classDefinition(antlr.collections.AST modifiers)
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### interfaceDefinition

          public final void interfaceDefinition(antlr.collections.AST modifiers)
                                         throws antlr.RecognitionException,
                                                antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### enumDefinition

          public final void enumDefinition(antlr.collections.AST modifiers)
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationDefinition

          public final void annotationDefinition(antlr.collections.AST modifiers)
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### declaration

          public final void declaration()
                                 throws antlr.RecognitionException,
                                        antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeSpec

          public final void typeSpec(boolean addImagNode)
                              throws antlr.RecognitionException,
                                     antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### variableDefinitions

          public final void variableDefinitions(antlr.collections.AST mods,
                                                antlr.collections.AST t)
                                         throws antlr.RecognitionException,
                                                antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### classTypeSpec

          public final void classTypeSpec(boolean addImagNode)
                                   throws antlr.RecognitionException,
                                          antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### builtInTypeSpec

          public final void builtInTypeSpec(boolean addImagNode)
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### classOrInterfaceType

          public final void classOrInterfaceType(boolean addImagNode)
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeArgumentsOrDiamond

          public final void typeArgumentsOrDiamond()
                                            throws antlr.RecognitionException,
                                                   antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeArgumentSpec

          public final void typeArgumentSpec()
                                      throws antlr.RecognitionException,
                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### builtInTypeArraySpec

          public final void builtInTypeArraySpec(boolean addImagNode)
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeArgument

          public final void typeArgument()
                                  throws antlr.RecognitionException,
                                         antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### wildcardType

          public final void wildcardType()
                                  throws antlr.RecognitionException,
                                         antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeArgumentBounds

          public final void typeArgumentBounds()
                                        throws antlr.RecognitionException,
                                               antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeArguments

          public final void typeArguments()
                                   throws antlr.RecognitionException,
                                          antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeArgumentsOrParametersEnd

          protected final void typeArgumentsOrParametersEnd()
                                                     throws antlr.RecognitionException,
                                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### builtInType

          public final void builtInType()
                                 throws antlr.RecognitionException,
                                        antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### type

          public final void type()
                          throws antlr.RecognitionException,
                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### modifier

          public final void modifier()
                              throws antlr.RecognitionException,
                                     antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotation

          public final void annotation()
                                throws antlr.RecognitionException,
                                       antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationArguments

          public final void annotationArguments()
                                         throws antlr.RecognitionException,
                                                antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationMemberValueInitializer

          public final void annotationMemberValueInitializer()
                                                      throws antlr.RecognitionException,
                                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### anntotationMemberValuePairs

          public final void anntotationMemberValuePairs()
                                                 throws antlr.RecognitionException,
                                                        antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationMemberValuePair

          public final void annotationMemberValuePair()
                                               throws antlr.RecognitionException,
                                                      antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### conditionalExpression

          public final void conditionalExpression()
                                           throws antlr.RecognitionException,
                                                  antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationMemberArrayInitializer

          public final void annotationMemberArrayInitializer()
                                                      throws antlr.RecognitionException,
                                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationMemberArrayValueInitializer

          public final void annotationMemberArrayValueInitializer()
                                                           throws antlr.RecognitionException,
                                                                  antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### superClassClause

          public final void superClassClause()
                                      throws antlr.RecognitionException,
                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeParameters

          public final void typeParameters()
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### implementsClause

          public final void implementsClause()
                                      throws antlr.RecognitionException,
                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### classBlock

          public final void classBlock()
                                throws antlr.RecognitionException,
                                       antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### interfaceExtends

          public final void interfaceExtends()
                                      throws antlr.RecognitionException,
                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### interfaceBlock

          public final void interfaceBlock()
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### enumBlock

          public final void enumBlock()
                               throws antlr.RecognitionException,
                                      antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationBlock

          public final void annotationBlock()
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeParameter

          public final void typeParameter()
                                   throws antlr.RecognitionException,
                                          antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### typeParameterBounds

          public final void typeParameterBounds()
                                         throws antlr.RecognitionException,
                                                antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### classField

          public final void classField()
                                throws antlr.RecognitionException,
                                       antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### interfaceField

          public final void interfaceField()
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### annotationField

          public final void annotationField()
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### enumConstant

          public final void enumConstant()
                                  throws antlr.RecognitionException,
                                         antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### declaratorBrackets

          public final void declaratorBrackets(antlr.collections.AST typ)
                                        throws antlr.RecognitionException,
                                               antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### argList

          public final void argList()
                             throws antlr.RecognitionException,
                                    antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### enumConstantBlock

          public final void enumConstantBlock()
                                       throws antlr.RecognitionException,
                                              antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### enumConstantField

          public final void enumConstantField()
                                       throws antlr.RecognitionException,
                                              antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### parameterDeclarationList

          public final void parameterDeclarationList()
                                              throws antlr.RecognitionException,
                                                     antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### throwsClause

          public final void throwsClause()
                                  throws antlr.RecognitionException,
                                         antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### compoundStatement

          public final void compoundStatement()
                                       throws antlr.RecognitionException,
                                              antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### ctorHead

          public final void ctorHead()
                              throws antlr.RecognitionException,
                                     antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### constructorBody

          public final void constructorBody()
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### explicitConstructorInvocation

          public final void explicitConstructorInvocation()
                                                   throws antlr.RecognitionException,
                                                          antlr.TokenStreamException

      Catch obvious constructor calls, but not the expr.super(...) calls
      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### statement

          public final void statement()
                               throws antlr.RecognitionException,
                                      antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### variableDeclarator

          public final void variableDeclarator(antlr.collections.AST mods,
                                               antlr.collections.AST t)
                                        throws antlr.RecognitionException,
                                               antlr.TokenStreamException

      Declaration of a variable. This can be a class/instance variable, or a local variable in a method It can also include possible initialization.
      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### varInitializer

          public final void varInitializer()
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### initializer

          public final void initializer()
                                 throws antlr.RecognitionException,
                                        antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### arrayInitializer

          public final void arrayInitializer()
                                      throws antlr.RecognitionException,
                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### expression

          public final void expression()
                                throws antlr.RecognitionException,
                                       antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### parameterDeclaration

          public final void parameterDeclaration()
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### variableLengthParameterDeclaration

          public final void variableLengthParameterDeclaration()
                                                        throws antlr.RecognitionException,
                                                               antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### parameterModifier

          public final void parameterModifier()
                                       throws antlr.RecognitionException,
                                              antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### forStatement

          public final void forStatement()
                                  throws antlr.RecognitionException,
                                         antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### casesGroup

          public final void casesGroup()
                                throws antlr.RecognitionException,
                                       antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### tryBlock

          public final void tryBlock()
                              throws antlr.RecognitionException,
                                     antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### forInit

          public final void forInit()
                             throws antlr.RecognitionException,
                                    antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### traditionalForClause

          public final void traditionalForClause()
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### forEachClause

          public final void forEachClause()
                                   throws antlr.RecognitionException,
                                          antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### forCond

          public final void forCond()
                             throws antlr.RecognitionException,
                                    antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### forIter

          public final void forIter()
                             throws antlr.RecognitionException,
                                    antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### aCase

          public final void aCase()
                           throws antlr.RecognitionException,
                                  antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### caseSList

          public final void caseSList()
                               throws antlr.RecognitionException,
                                      antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### expressionList

          public final void expressionList()
                                    throws antlr.RecognitionException,
                                           antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### handler

          public final void handler()
                             throws antlr.RecognitionException,
                                    antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### finallyClause

          public final void finallyClause()
                                   throws antlr.RecognitionException,
                                          antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### multicatch

          public final void multicatch()
                                throws antlr.RecognitionException,
                                       antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### multicatch_types

          public final void multicatch_types()
                                      throws antlr.RecognitionException,
                                             antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### assignmentExpression

          public final void assignmentExpression()
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### logicalOrExpression

          public final void logicalOrExpression()
                                         throws antlr.RecognitionException,
                                                antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### logicalAndExpression

          public final void logicalAndExpression()
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### inclusiveOrExpression

          public final void inclusiveOrExpression()
                                           throws antlr.RecognitionException,
                                                  antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### exclusiveOrExpression

          public final void exclusiveOrExpression()
                                           throws antlr.RecognitionException,
                                                  antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### andExpression

          public final void andExpression()
                                   throws antlr.RecognitionException,
                                          antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### equalityExpression

          public final void equalityExpression()
                                        throws antlr.RecognitionException,
                                               antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### relationalExpression

          public final void relationalExpression()
                                          throws antlr.RecognitionException,
                                                 antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### shiftExpression

          public final void shiftExpression()
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### additiveExpression

          public final void additiveExpression()
                                        throws antlr.RecognitionException,
                                               antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### multiplicativeExpression

          public final void multiplicativeExpression()
                                              throws antlr.RecognitionException,
                                                     antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### unaryExpression

          public final void unaryExpression()
                                     throws antlr.RecognitionException,
                                            antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### unaryExpressionNotPlusMinus

          public final void unaryExpressionNotPlusMinus()
                                                 throws antlr.RecognitionException,
                                                        antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### postfixExpression

          public final void postfixExpression()
                                       throws antlr.RecognitionException,
                                              antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### primaryExpression

          public final void primaryExpression()
                                       throws antlr.RecognitionException,
                                              antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### newExpression

          public final void newExpression()
                                   throws antlr.RecognitionException,
                                          antlr.TokenStreamException

      object instantiation. Trees are built as illustrated by the following input/tree pairs: new T() new | T -- ELIST | arg1 -- arg2 -- .. -- argn new int[] new | int -- ARRAY_DECLARATOR new int[] {1,2} new | int -- ARRAY_DECLARATOR -- ARRAY_INIT | EXPR -- EXPR | | 1 2 new int[3] new | int -- ARRAY_DECLARATOR | EXPR | 3 new int[1][2] new | int -- ARRAY_DECLARATOR | ARRAY_DECLARATOR -- EXPR | | EXPR 1 | 2
      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### identPrimary

          public final void identPrimary()
                                  throws antlr.RecognitionException,
                                         antlr.TokenStreamException

      Match a, a.b.c refs, a.b.c(...) refs, a.b.c[], a.b.c[].class, and a.b.c.class refs. Also this(...) and super(...). Match this or super.
      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### constant

          public final void constant()
                              throws antlr.RecognitionException,
                                     antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### newArrayDeclarator

          public final void newArrayDeclarator()
                                        throws antlr.RecognitionException,
                                               antlr.TokenStreamException

      Throws:
        `antlr.RecognitionException`
        `antlr.TokenStreamException`

    - #### buildTokenTypeASTClassMap

          protected void buildTokenTypeASTClassMap()